//based on Tutorial (https://learnopengl.com/#!Lighting/Multiple-lights) by JoeyDeVries

#version 430 core
layout (location = 0) in vec3 in_position;
layout (location = 1) in vec3 in_normal;
layout (location = 2) in vec2 in_texCoords;

out vec2 texCoords;
out vec3 normal;
out vec3 fragmentPosition;
out vec4 fragmentPositionLightSpace;

uniform mat4 model;
uniform mat4 view;
uniform mat4 projection;
uniform mat4 lightSpaceMatrix;

void main()
{
	fragmentPosition = vec3(model * vec4(in_position, 1.0f));
    normal = mat3(transpose(inverse(model))) * in_normal;  
    texCoords = in_texCoords;
	fragmentPositionLightSpace = lightSpaceMatrix * vec4(fragmentPosition, 1.0); // for Shadow Mapping
	gl_Position = projection * view * model * vec4(in_position, 1.0f);
}