//based on Tutorial (https://learnopengl.com/#!Advanced-Lighting/Bloom) by JoeyDeVries
#version 430 core
out vec4 FragColor;
  
in vec2 texCoords;

uniform sampler2D image;
  
uniform bool horizontal;
const int fSize = 12;
uniform float weight[fSize] = float[] (0.1390,    0.1308,    0.1091,    0.0805,    0.0526,    0.0305,    0.0156,    0.0071,    0.0029,    0.0010,    0.0003,    0.0001);

void main()
{             
    vec2 tex_offset = 1.0 / textureSize(image, 0); // gets size of single texel
    vec3 result = texture(image, texCoords).rgb * weight[0]; // current fragment's contribution
    if(horizontal)
    {
        for(int i = 1; i < fSize; ++i)
        {
            result += texture(image, texCoords + vec2(tex_offset.x * i, 0.0)).rgb * weight[i];
            result += texture(image, texCoords - vec2(tex_offset.x * i, 0.0)).rgb * weight[i];
        }
    }
    else
    {
        for(int i = 1; i < fSize; ++i)
        {
            result += texture(image, texCoords + vec2(0.0, tex_offset.y * i)).rgb * weight[i];
            result += texture(image, texCoords - vec2(0.0, tex_offset.y * i)).rgb * weight[i];
        }
    }
    FragColor = vec4(result, 1.0);
}