#version 430 core
layout (location = 0) in vec4 in_particle_position1;
layout (location = 1) in vec4 in_particle_color1;
layout (location = 2) in vec4 in_particle_position2;
layout (location = 3) in vec4 in_particle_color2;
layout (location = 4) in vec3 in_vertex_position;

uniform mat4 view;
uniform mat4 projection;
uniform bool useBuf1;

out vec4 pCol;

void main()
{

	mat4 model = mat4(1.0);
	vec4 particle_position;
	if(useBuf1)
	{
		particle_position = in_particle_position1;
		pCol = in_particle_color1;
	}
	else
	{
		particle_position = in_particle_position2;
		pCol = in_particle_color2;
	}
	model[3][0] = particle_position.x;
	model[3][1] = particle_position.y;
	model[3][2] = particle_position.z;
	

	//model[0][0] = model[1][1] = model[2][2] = 1.0f;
	

	gl_Position = projection * view * model *  vec4(in_vertex_position, 1.0f);
}